'May 2016
'Updated for true false hdmiinputstatus
'returns "hdmi" if hdmi connected, "nohmdi" if not

'2018
'add check for device_present to see if cable plugged in but no signal

Function hdmi_Initialize(msgPort As Object, userVariables As Object, bsp as Object)
    print "hdmi_Initialize - entry"
    hdmi = newhdmi(msgPort, userVariables, bsp)
    return hdmi
End Function


Function newhdmi(msgPort As Object, userVariables As Object, bsp as Object)
	print "newhdmi"

	s = {}
	s.version = 0.56
	s.msgPort = msgPort
	s.userVariables = userVariables
	s.bsp = bsp
	s.ProcessEvent = hdmi_ProcessEvent
	s.checknow = hdmi_checknow
	s.hdmistatus$ = ""
	s.objectName = "hdmi_object"
	s.debug  = false
	
	s.dlog = createobject("roSystemLog")
	s.mymode = createobject("roVideoMode")
	s.mymode.setport(msgport)
	s.checknow()	'checks if hdmi plugged in at when project runs
	return s
	
End Function


Function hdmi_ProcessEvent(event As Object) as boolean
	print "Processing myhdmi plugin events"
	retval = false

	if type(event) = "roAssociativeArray" then
        	if type(event["EventType"]) = "roString" then
             		if (event["EventType"] = "SEND_PLUGIN_MESSAGE") then
                		if event["PluginName"] = "hdmi" then
                    		pluginMessage$ = event["PluginMessage"]
					print "SEND_PLUGIN/EVENT_MESSAGE:";pluginMessage$
                    		retval = ParsePluginMsg(pluginMessage$, m)
                		endif
            		endif
        	endif

	else if type(event) = "roHdmiInputChanged" then
		m.bsp.diagnostics.PrintDebug("hdmi plug event")
		m.checknow()
		retval=true	'don't let ba process the event again
	end if

	return retval

End Function


'added 5-7-15
Sub hdmi_send_event(msgport as object, status$ as string)
	pluginMessageCmd = CreateObject("roAssociativeArray")
	pluginMessageCmd["EventType"] = "EVENT_PLUGIN_MESSAGE"
	pluginMessageCmd["PluginName"] = "hdmi"
	pluginMessageCmd["PluginMessage"] = status$
	msgPort.PostMessage(pluginMessageCmd)
end Sub

Sub hdmi_checknow()
		status$="nohdmi"
		hs = m.mymode.gethdmiinputstatus()
		if hs <> invalid then
			status$ ="hdmi"
			if hs.width <> invalid then 
				m.bsp.diagnostics.printdebug("@@@@@Type width:" + type(hs.width))
				m.bsp.diagnostics.printdebug("@@@@@signal width:" + str(hs.width))
			else
				m.bsp.diagnostics.printdebug("@@@@@signal width value not found")
				status$="nohdmi"

			endif

		else	'nothing is plugged into hdmi input
			print "No HDMI detected"
		endif
		
		hdmi_send_event(m.msgport, status$)
end Sub
